var gutil = require('gulp-util');

var helpers = {};

helpers.checkConfig = function (myConfig, exampleConfig) {
  myConfig = (myConfig && typeof myConfig === 'object') ? myConfig : {};
  var config = {};

  var myConfigValue;
  for (var key in exampleConfig) {
    myConfigValue = myConfig[key];
    if (myConfigValue !== undefined && myConfigValue !== null) {
      config[key] = myConfigValue;
    } else {
      gutil.log(gutil.colors.yellow('Warning: Using Example Config value for: ' + key));
      config[key] = exampleConfig[key];
    }
  }

  return config;
};

helpers.gutilLog = function(msg, color) {
  color = color && (gutil.colors[color] ? color : 'green') || 'green';
  gutil.log(gutil.colors[color](msg));
};

helpers.errorToPlumber = function(error) {
  gutil.beep();
  helpers.gutilLog(error.message, 'red');
};

helpers.onError = function(error) {
  gutil.beep();
  helpers.gutilLog(error.message, 'red');
  if (error.line) {
    helpers.gutilLog(error.line, 'yellow');
  }
};

helpers.requireUncached = function($module) {
  delete require.cache[require.resolve($module)];
  return require($module);
};

module.exports = helpers;
